Index: libabac/abac_attribute.c
===================================================================
--- libabac/abac_attribute.c	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_attribute.c	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -1,3 +1,2 @@
-
 /**
 **  abac_attribute.c
@@ -9,23 +8,23 @@
 #include <time.h>
 
-#include "abac_internal.h"
+#include <credentials/certificates/x509.h>
+#include <credentials/certificates/certificate.h>
+#include <credentials/certificates/ac.h>
+
 #include "abac_util.h"
-#include "abac_rt.h"
-
-#define SHA1_LENGTH 40
-
-extern char* abac_encode_string(char*);
-extern abac_key_t *abac_id_keyptr(abac_id_t *id);
-extern abac_aspect_t *abac_yy_get_rule_head_aspect();
-extern abac_aspect_t *abac_yy_get_rule_tail_aspect();
-extern abac_list_t *abac_yy_get_rule_clauses();
-extern char* abac_decode_string(char *);
-extern void abac_yy_free_rule_clauses();
-extern int verify_signature(certificate_t *issuer_cert, certificate_t *cert);
-
-abac_attribute_t *abac_attribute_set_head(abac_attribute_t *ptr, abac_aspect_t *head);
-
+#include "abac_aspect.h"
+#include "abac_m64.h"
+#include "abac_id.h"
+#include "abac_pl_yy.h"
+#include "rt2_yy.h"
+#include "abac_verifier.h"
+#include "abac_util_cert.h"
+#include "abac_id.h"
+
+/*****************************************************************/
 static int debug=0;
 
+/* the correct setting of using_this depends on user if the attribute is
+   not generate from yyparse call */
 struct _abac_attribute_t {
     abac_id_t *issuer_id; 
@@ -33,4 +32,5 @@
     abac_aspect_t *tail;
     int validity;
+    int using_this; /* tracking use of (?This) */
     certificate_t *cert; // NULL until baked
     certificate_t *issuer_cert;
@@ -39,5 +39,13 @@
 };
 
+/* local */
+abac_attribute_t *abac_attribute_set_head(abac_attribute_t *ptr, abac_aspect_t *head);
+abac_aspect_t *abac_attribute_head(abac_attribute_t *ptr);
+abac_aspect_t *abac_attribute_tail(abac_attribute_t *ptr);
+abac_attribute_t *abac_attribute_add_tail(abac_attribute_t *ptr, abac_aspect_t *tail);
+void abac_attribute_set_using_this(abac_attribute_t *ptr, int using_this);
+
 /********************************************************************/
+/* currently the hashkeyid is the uuencoded 'sha attribute string'  */
 char *get_cred_encoding(abac_attribute_t *ptr)
 {
@@ -48,4 +56,16 @@
     assert(ptr->tail != NULL);
 
+    if(ptr->cert != NULL) { /* already a baked one */
+        ac_t *ac = (ac_t *)ptr->cert;
+        ietf_attributes_t *attr_cert = ac->get_groups(ac);
+        char *encoded_attr_string=attr_cert->get_string(attr_cert);
+        return encoded_attr_string;
+    }
+
+    /* not a baked one should not be in ABAC_CN mode at all !!! */
+    /* needs to be the one with sha */
+    if(USE("ABAC_CN")) {
+        fprintf(stderr,"get_cred_encoding, MIGHT be BAD..\n");
+    } 
     char *head_string=abac_aspect_typed_string_with_condition(ptr->head);
     char *tail_string=abac_aspect_typed_string_with_condition(ptr->tail);
@@ -54,5 +74,7 @@
     char* base64_encoding=abac_encode_string(encoding);
 
-    if(debug) fprintf(stderr,"XXX abac_attribute_bake (%s)\n", encoding);
+    if(USE("ABAC_CN")) {
+        fprintf(stderr,"    --> (%s)\n", encoding);
+    }
 
     free(encoding);
@@ -62,23 +84,35 @@
 }
 
+static abac_attribute_t *_abac_attribute_init()
+{
+    abac_attribute_t *ptr = abac_xmalloc(sizeof(abac_attribute_t));
+    ptr->issuer_id = NULL;
+    ptr->head = NULL;
+    ptr->tail = NULL;
+    ptr->validity= 365 * 86400; // default
+    // NULL until baked
+    ptr->using_this=0;
+    ptr->cert= NULL;
+    ptr->issuer_cert= NULL;
+    ptr->refcount=1;
+    return ptr;
+}
+
 /********************************************************************/
 abac_attribute_t *abac_attribute_new(abac_id_t *issuer, certificate_t *cert,
 certificate_t *issuer_cert)
 {
-    abac_attribute_t *ptr = abac_xmalloc(sizeof(abac_attribute_t));
+    abac_attribute_t *ptr = _abac_attribute_init();
     ptr->issuer_id = abac_id_dup(issuer);
-    ptr->head = NULL;
-    ptr->tail = NULL;
-    ptr->validity= 365 * 86400; // default
     ptr->cert=cert; // already baked..
     ptr->issuer_cert=issuer_cert;
     ptr->refcount=1;
-
     return ptr;
 }
 
 // validity is measured in seconds (as of 0.2.0)
-int abac_attribute_create(abac_attribute_t **ret, 
-abac_aspect_t *head, abac_aspect_t *tail, int validity)
+// remember using_this,
+int abac_attribute_create(abac_attribute_t **ret, abac_aspect_t *head, 
+abac_aspect_t *tail, int validity)
 {
     abac_id_t *issuer_id=abac_aspect_get_issuer_id(head);
@@ -95,14 +129,11 @@
         return ABAC_ATTRIBUTE_INVALID_VALIDITY;
 
-    abac_attribute_t *ptr = abac_xmalloc(sizeof(abac_attribute_t));
+    abac_attribute_t *ptr = _abac_attribute_init();
     ptr->issuer_id = abac_id_dup(issuer_id);
     ptr->head = abac_aspect_dup(head);
-    ptr->tail = (tail!=NULL) ? abac_aspect_dup(tail):NULL;
+    if(tail)
+        ptr->tail = abac_aspect_dup(tail);
     ptr->validity=(validity==0?(365 * 86400):validity);
 
-    // NULL until baked
-    ptr->cert=NULL;
-    ptr->issuer_cert=NULL;
-    ptr->refcount=1;
     *ret = ptr;
     return ABAC_ATTRIBUTE_SUCCESS;
@@ -111,5 +142,6 @@
 // validity is measured in seconds (as of 0.2.0)
 int abac_attribute_create_creddy(abac_attribute_t **ret, abac_id_t *issuer, 
-abac_aspect_t *head_aspect, abac_aspect_t *tail_aspect, char *name, int validity)
+abac_aspect_t *head_aspect, abac_aspect_t *tail_aspect, char *name,
+int validity)
 {
     if (!abac_id_has_privkey(issuer))
@@ -120,16 +152,41 @@
         return ABAC_ATTRIBUTE_INVALID_VALIDITY;
 
-    abac_attribute_t *ptr = abac_xmalloc(sizeof(abac_attribute_t));
+    abac_attribute_t *ptr = _abac_attribute_init();
     ptr->issuer_id = abac_id_dup(issuer);
-
     ptr->head=head_aspect;
     ptr->tail=tail_aspect;
     ptr->validity = validity;
 
-    // NULL until baked
-    ptr->cert = NULL;
-    ptr->issuer_cert = NULL;
     *ret = ptr;
     return ABAC_ATTRIBUTE_SUCCESS;
+}
+
+static void _check_cert_group(certificate_t *cert, char *estring)
+{
+    ietf_attributes_t *attr_cert = NULL;
+    int ret, i;
+
+    // get the attr
+    ac_t *ac = (ac_t *)cert;
+    attr_cert = ac->get_groups(ac);
+    if(attr_cert == NULL) {
+        fprintf(stderr,"BAD group from the cert !!!\n");
+        return;
+    }
+    char *encoded_attr_string=attr_cert->get_string(attr_cert);
+    if(encoded_attr_string==NULL) {
+        fprintf(stderr,"BAD empty, encoded attr string from the cert !!!\n");
+/*
+    chunk_t b64 = chunk_to_base64(chunk, NULL);
+    chunk_t chk = chunk_from_base64(base64, NULL);
+*/
+       int len = strlen(estring);
+       chunk_t b64 = { estring, len };
+       chunk_t chk= chunk_from_base64(b64, NULL);
+       chk.ptr[chk.len]='\0';
+       fprintf(stderr,"new convert: (%s)\n", chk.ptr);
+       chunk_t nb64 = chunk_to_base64(chk, NULL);
+       fprintf(stderr,"back again: (%d)(%s)\n", strlen(nb64.ptr), nb64.ptr);
+    }
 }
 
@@ -148,4 +205,10 @@
     if(private==NULL)
         errx(1,"can not bake without a private key!!!"); 
+
+/**** XXX this needs to be removed !!!!! limitation from strongswan... ****/
+    if(strlen(cred_encoding) > 512) {
+        fprintf(stderr,"due to BUILD_IETF_GROUP_ATTR buffer size limit, can not bake this attribute (%d)!!\n", strlen(cred_encoding));
+        return 0;
+    }
 
     certificate_t *attr_cert = lib->creds->create(lib->creds,
@@ -161,4 +224,6 @@
     );
 
+    _check_cert_group(attr_cert, cred_encoding);
+
     DESTROY_IF(private);
 
@@ -189,9 +254,6 @@
 
     libabac_init();
-    certificate_t *cert = lib->creds->create(lib->creds,
-        CRED_CERTIFICATE, CERT_X509_AC,
-        BUILD_FROM_FILE, filename,
-        BUILD_END
-    );
+
+    certificate_t *cert = cert_get_attr_cert_from_file(filename);
     if (cert == NULL)
         errx(1, "Couldn't load attribute cert %s", filename);
@@ -209,9 +271,5 @@
 
     libabac_init();
-    certificate_t *cert = lib->creds->create(lib->creds,
-        CRED_CERTIFICATE, CERT_X509_AC,
-        BUILD_BLOB_ASN1_DER, chunk,
-        BUILD_END
-    );
+    certificate_t *cert = cert_get_attr_cert_from_chunk(chunk);
     if (cert == NULL)
         errx(1, "Couldn't load attribute chunk");
@@ -227,7 +285,9 @@
  * attribute string is parsed via yyparse call
  */
-static abac_attribute_t *_load_attribute_from_cert(certificate_t *cert) {
+static abac_attribute_t *_load_attribute_from_cert(certificate_t *cert)
+{
     ietf_attributes_t *attr_cert = NULL;
     int ret, i;
+    int using_this=0;
 
     // get the attr
@@ -249,23 +309,15 @@
     }
 
-    /* call into yacc parser */
-    abac_reset_yyfptr(attr_string);
-    abac_yy_init();
-    int rc=yyparse();
+    abac_id_credential_t *id_cred;
+    abac_id_t *issuer_id;
+
+    /* reset lex input line, call into yacc parser */
+    abac_aspect_t *head_aspect = NULL;
+    abac_aspect_t *tail_aspect = NULL;
+    int rc=abac_yy_parse(NULL, attr_string, &head_aspect, &tail_aspect, &using_this);
     if (rc) {
         ret = ABAC_CERT_INVALID;
         goto error;
     }
-
-    abac_aspect_t *head_aspect = NULL;
-    abac_aspect_t *tail_aspect = NULL;
-    abac_list_t *clauses=NULL;
-    abac_id_credential_t *id_cred;
-    abac_id_t *issuer_id;
-
-    // get the attr
-    head_aspect = abac_yy_get_rule_head_aspect();
-    tail_aspect = abac_yy_get_rule_tail_aspect();
-    clauses = abac_yy_get_rule_clauses();
 
     // get the issuer based on keyid
@@ -300,4 +352,5 @@
     abac_attribute_set_head(attr, head_aspect);
     abac_attribute_add_tail(attr, tail_aspect);
+    abac_attribute_set_using_this(attr, using_this);
 
     // free up some stuff
@@ -344,6 +397,39 @@
 {
     assert(ptr);
+    abac_id_dup(ptr->issuer_id);
     ++ptr->refcount;
     return ptr;
+}
+
+static certificate_t *_cert_copy(certificate_t *cert)
+{
+    if(cert==NULL) return NULL;
+    chunk_t encoding = chunk_empty;
+    int rc=cert->get_encoding(cert,CERT_ASN1_DER,&encoding);
+    certificate_t *ncert = cert_get_attr_cert_from_chunk(encoding);
+    return ncert;
+}
+
+/* deep copy of a attribute structure, this is used by libabac
+   api so that we can have a local control of the data within
+   libabac
+*/
+abac_attribute_t *abac_attribute_copy(abac_attribute_t *ptr)
+{
+    assert(ptr);
+    abac_aspect_t *tmp;
+    abac_attribute_t *nptr = _abac_attribute_init();
+    nptr->issuer_id = abac_id_copy(ptr->issuer_id);
+    nptr->head=abac_aspect_copy(abac_attribute_head(ptr));
+    nptr->tail=abac_aspect_copy(abac_attribute_tail(ptr));
+
+    nptr->validity= ptr->validity;
+    nptr->using_this = ptr->using_this;
+    certificate_t *attr_cert=_cert_copy(ptr->cert);
+    nptr->cert=attr_cert; // already baked..
+    if(attr_cert) 
+        nptr->issuer_cert= attr_cert->get_ref(attr_cert);
+    nptr->refcount=ptr->refcount+1;
+    return nptr;
 }
 
@@ -364,5 +450,4 @@
     if(ptr->cert) DESTROY_IF(ptr->cert);
     if(ptr->issuer_cert) DESTROY_IF(ptr->issuer_cert);
-
     free(ptr);
 }
@@ -415,4 +500,16 @@
     ptr->head=head;
     return ptr;
+}
+
+void abac_attribute_set_using_this(abac_attribute_t *ptr, int using_this)
+{
+    assert(ptr);
+    ptr->using_this=using_this;
+}
+
+int abac_attribute_get_this(abac_attribute_t *ptr)
+{
+    assert(ptr);
+    return ptr->using_this;
 }
 
Index: libabac/abac_attribute.h
===================================================================
--- libabac/abac_attribute.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
+++ libabac/abac_attribute.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -0,0 +1,16 @@
+#ifndef __ABAC_ATTR_H__
+#define __ABAC_ATTR_H__
+
+#include "abac_defines.h"
+
+#include <credentials/certificates/certificate.h>
+
+/* exported */
+extern char *get_cred_encoding(abac_attribute_t *);
+extern certificate_t *abac_attribute_issuer_cert(abac_attribute_t *ptr);
+extern certificate_t *abac_attribute_cert(abac_attribute_t *ptr);
+extern abac_attribute_t *abac_attribute_new(abac_id_t *, certificate_t *, certificate_t *);
+extern abac_attribute_t *abac_attribute_dup(abac_attribute_t *);
+extern abac_attribute_t *abac_attribute_copy(abac_attribute_t *);
+
+#endif /* __ABAC_ATTR_H__ */
Index: libabac/abac_c.c
===================================================================
--- libabac/abac_c.c	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_c.c	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -1,7 +1,18 @@
+/**
+** abac_c.c
+** a very thin layer to libabac calls so c interface 
+** and c++ interface looks about the same 
+**
+** This should be 'macrotized' when we go to beta to minimumize
+** runtime function call cost
+**/
 
 #include "abac_internal.h"
-
-/* a very thin layer to libabac calls so c interface and c++ interface
-   looks about the same */
+#include "abac_util.h"
+
+/**************************************************************************/
+/* utility */
+char *abac_get_version()
+{ return abac_xstrdup(abac_version()); }
 
 /* CONSTRAINT->abac_condition_t */
@@ -164,29 +175,27 @@
 
 /* CONTEXT -> abac_context_t */
-int abac_context_load_id(abac_context_t *ptr, abac_id_t *id)
-{ return abac_context_load_id_id(ptr, id); }
+int abac_context_principal_count(abac_context_t *ptr)
+{ return abac_context_id_creds_count(ptr); }
+int abac_context_credential_count(abac_context_t *ptr)
+{ return abac_context_creds_count(ptr); }
 int abac_context_load_id_file(abac_context_t *ptr, char *filename)
 { return abac_context_load_id_idkey_file(ptr, filename); }
 int abac_context_load_id_files(abac_context_t *ptr, char *filename, char *keyfilename)
-{ return abac_context_load_id_id_file_key_file(ptr, filename, keyfilename); }
-int abac_context_load_attribute(abac_context_t *ptr, abac_attribute_t *attr)
-{ return abac_context_load_attribute_attribute(ptr, attr); }
+{ return abac_context_load_id_id_key_files(ptr, filename, keyfilename); }
 
 /* encrypted version */
-int abac_context_load_encrypted_id_file(abac_context_t *ptr, char *filename,
-char *pfile)
+int abac_context_load_encrypted_id_file(abac_context_t *ptr, char *filename, char *pfile)
 { return abac_context_load_id_enc_idkey_file(ptr, filename, pfile); }
-int abac_context_load_encrypted_id_files(abac_context_t *ptr, char *filename,
-char *keyfilename, char *pfile)
-{ return abac_context_load_id_enc_id_file_key_file(ptr, filename, keyfilename, pfile); }
-
-
-
-
-
-
-
-
-
-
-
+int abac_context_load_encrypted_id_files(abac_context_t *ptr, char *filename, char *keyfilename, char *pfile)
+{ return abac_context_load_id_enc_id_key_files(ptr, filename, keyfilename, pfile); }
+abac_id_credential_t *abac_context_principal_lookup(abac_context_t *ptr,char *nm)
+{ return abac_context_id_credential_lookup(ptr,nm); }
+
+
+
+
+
+
+
+
+
Index: libabac/abac_c.h
===================================================================
--- libabac/abac_c.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
+++ libabac/abac_c.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -0,0 +1,70 @@
+#ifndef __ABAC_C_H__
+#define __ABAC_C_H__
+
+/* export visible routines from abac_c.c */
+extern void abac_constraint_add_integer_max(abac_condition_t *cond,int val);
+extern void abac_constraint_add_integer_min(abac_condition_t *cond,int val);
+extern void abac_constraint_add_integer_target(abac_condition_t *cond,int val);
+extern void abac_constraint_add_float_max(abac_condition_t *cond,float val);
+extern void abac_constraint_add_float_min(abac_condition_t *cond,float val);
+extern void abac_constraint_add_float_target(abac_condition_t *cond,float val);
+extern void abac_constraint_add_time_max(abac_condition_t *cond,char* val);
+extern void abac_constraint_add_time_min(abac_condition_t *cond,char* val);
+extern void abac_constraint_add_time_target(abac_condition_t *cond,char* val);
+extern void abac_constraint_add_urn_target(abac_condition_t *cond,char* val);
+extern void abac_constraint_add_string_target(abac_condition_t *cond,char* val);
+extern void abac_constraint_add_boolean_target(abac_condition_t *cond, char* val);
+extern abac_condition_t *abac_constraint_from_role(abac_aspect_t *ptr);
+extern abac_condition_t *abac_constraint_create(char *vtype);
+extern abac_condition_t *abac_constraint_from_oset(abac_aspect_t *ptr);
+extern char *abac_constraint_typed_string(abac_condition_t *ptr);
+extern char *abac_constraint_string(abac_condition_t *ptr);
+extern abac_aspect_t *abac_role_principal_create(char *principal_name);
+extern abac_aspect_t *abac_oset_principal_create(char *principal_name);
+extern abac_aspect_t *abac_oset_create(char *principal_name, char *oset_name);
+extern abac_aspect_t *abac_role_create(char *principal_name, char *role_name);
+extern abac_aspect_t *abac_oset_linked_create(char *principal_name, char *linked_role_name, char *oset_name);
+extern abac_aspect_t *abac_role_linked_create(char *principal_name, char *linked_role_name, char *role_name);
+extern abac_aspect_t *abac_oset_object_create(abac_term_t *object);
+extern int abac_oset_is_object(abac_aspect_t *ptr);
+extern int abac_oset_is_principal(abac_aspect_t *ptr);
+extern int abac_role_is_principal(abac_aspect_t *ptr);
+extern int abac_oset_is_linking(abac_aspect_t *ptr);
+extern int abac_role_is_linking(abac_aspect_t *ptr);
+extern char *abac_role_linked_role(abac_aspect_t *ptr);
+extern char *abac_oset_linked_role(abac_aspect_t *ptr);
+extern char *abac_role_name(abac_aspect_t *ptr);
+extern char *abac_oset_name(abac_aspect_t *ptr);
+extern char *abac_role_principal(abac_aspect_t *ptr);
+extern char *abac_oset_principal(abac_aspect_t *ptr);
+extern void abac_role_add_data_term(abac_aspect_t *ptr, abac_term_t *param);
+extern void abac_oset_add_data_term(abac_aspect_t *ptr, abac_term_t *param);
+extern void abac_role_add_linked_data_term(abac_aspect_t *ptr, abac_term_t *param);
+extern void abac_oset_add_linked_data_term(abac_aspect_t *ptr, abac_term_t *param);
+extern char *abac_oset_object(abac_aspect_t *ptr);
+extern char *abac_oset_typed_string(abac_aspect_t *ptr);
+extern char *abac_oset_string(abac_aspect_t *ptr);
+extern char *abac_role_typed_string(abac_aspect_t *ptr);
+extern char *abac_role_string(abac_aspect_t *ptr);
+extern abac_term_t **abac_oset_get_data_terms(abac_aspect_t *ptr);
+extern abac_term_t **abac_oset_get_linked_data_terms(abac_aspect_t *ptr);
+extern abac_term_t **abac_role_get_data_terms(abac_aspect_t *ptr);
+extern abac_term_t **abac_role_get_linked_data_terms(abac_aspect_t *ptr);
+extern void abac_id_write_cert_fname(abac_id_t *ptr,char *filename);
+extern void abac_id_write_privkey_fname(abac_id_t *ptr,char *filename);
+extern int abac_id_load_encrypted_privkey_file(abac_id_t *ptr, char *filename, char *pfile);
+extern char *abac_head_string(abac_attribute_t *ptr);
+extern char *abac_tail_string(abac_attribute_t *ptr);
+extern char *abac_head_typed_string(abac_attribute_t *ptr);
+extern char *abac_tail_typed_string(abac_attribute_t *ptr);
+extern void abac_attribute_write_cert_fname(abac_attribute_t *ptr,char *filename);
+extern abac_aspect_t **abac_attribute_role_tails(abac_attribute_t *ptr);
+extern abac_aspect_t **abac_attribute_oset_tails(abac_attribute_t *ptr);
+extern int abac_context_load_id(abac_context_t *ptr, abac_id_t *id);
+extern int abac_context_load_id_idkey_file(abac_context_t *ptr, char *filename);
+extern int abac_context_load_id_files(abac_context_t *ptr, char *filename, char *keyfilename);
+extern int abac_context_load_attribute(abac_context_t *ptr, abac_attribute_t *attr);
+extern int abac_context_load_encrypted_id_file(abac_context_t *ptr, char *filename, char *pfile);
+extern int abac_context_load_encrypted_id_files(abac_context_t *ptr, char *filename, char *keyfilename, char *pfile);
+
+#endif /* __ABAC_C_H__ */
